#!/usr/bin/env node
const cp = require("child_process");
const fs = require("fs");
const sqlite3 = require('sqlite3');
const path = (process.env.HOME || process.env.USERPROFILE) + '/Library/Messages/';
fs.watchFile(path + 'chat.db-wal', (curr, prev) => {
  const db = new sqlite3.Database(path + 'chat.db', function () {
    db.run("select name from sqlite_master where type = 'table'", function () {
      db.all(`SELECT
      datetime (message.date / 1000000000 + strftime ("%s", "2001-01-01"), "unixepoch", "localtime") AS message_date,
      message.text,
      message.is_from_me,
      chat.chat_identifier
  FROM
      chat
      JOIN chat_message_join ON chat. "ROWID" = chat_message_join.chat_id
      JOIN message ON chat_message_join.message_id = message. "ROWID"
  ORDER BY
      message_date DESC
  limit 1`, function (err, res) {
        !err
          && (res[0].text.match(/(?<![0-9])([0-9]{6})(?![0-9])/) || res[0].text.match(/(?<![0-9])([0-9]{4})(?![0-9])/))
          && cp.spawnSync('pbcopy', { input: code[0], encoding: 'utf8' });
      });
    });
  });
});
